from flask import Blueprint, jsonify
from workflow.bilibili import INSTANCE as BILIBILI_INSTANCE

blueprint = Blueprint("api_biliuploader", __name__, url_prefix="/api/biliuploader")


@blueprint.get("/")
def get_login_info():
    return jsonify({
        "mid": BILIBILI_INSTANCE.user_id,
        "expires": BILIBILI_INSTANCE.expires,
        "login_at": BILIBILI_INSTANCE.login_time,
    })


@blueprint.post("/")
def do_login():
    BILIBILI_INSTANCE.login()
    return get_login_info()


@blueprint.post("/finish")
def finish_uploading():
    BILIBILI_INSTANCE.finish_upload()
