from time import sleep


class Retry:
    def __init__(self, max_retry, success_return_value, sleep_sec = 60):
        self.max_retry = max_retry
        self.success_return_value = success_return_value
        self.sleep_sec = 60

    def run(self, func, *args, **kwargs):
        status = False
        for i in range(0, self.max_retry):
            try:
                return_value = func(*args, **kwargs)
            except Exception:
                sleep(self.sleep_sec)
                continue
            if return_value == self.success_return_value:
                status = True
                break
        return status
